﻿#include "toptemplateclass0.h"

/*!
 * \class TopTemplateClass0
 * \brief 空模板
 */

TopTemplateClass0::TopTemplateClass0(const QString &iModuleName,
                                     const QVariantMap &iUrlPars,
                                     QWidget *iParent)
    : TopClassAbs(iParent)
{
    initModule(iModuleName, iUrlPars);
    QString licenseKey = config("sys_license_key").toString();
    if (!licenseKey.isEmpty()) {
        setLicenseKey(licenseKey);
    }
    QStringList langLst = config("sys_lang_list").toStringList();
    for (const auto &lang : langLst) {
        appendLanguage(lang);
    }
    if (isHookExists("afterModuleInit")) {
        callHooks("afterModuleInit");
    }
    initUi();
    if (isHookExists("afterViewInit")) {
        callHooks("afterViewInit");
    }
}

TopTemplateClass0::~TopTemplateClass0()
{
    if (isHookExists("onDestroy")) {
        callHooks("onDestroy");
    }
}

/*!
 * \brief 初始化界面
 */
void TopTemplateClass0::initUi()
{
    // Do nothing
}
