﻿#ifndef TEMPLATECLASS1_H
#define TEMPLATECLASS1_H

#include <topcore/topclassabs.h>
#include <topcore/topclasshelper.h>

class QWidget;
class TSearchEntry;
class TPageTool;
class TTableView;

class TopTemplateClass1 : public TopClassAbs
{
    Q_OBJECT
public:
    explicit TopTemplateClass1(const QString &iModuleName = QString(""),
                               const QVariantMap &iUrlPars = QVariantMap(),
                               QWidget *iParent = nullptr);
    ~TopTemplateClass1();
public slots:
    void refresh(bool iResetPage = true);
    TTableView *tableView() const;
    QVariantList selectedItems() const;
    QVariantList selectedDataMaps() const;
private slots:
    void onSelectionChanged();
    void onPageChanged();
private:
    void initUi();
private:
    QWidget *mBodyWgt = nullptr;
    TTableView *mTableView = nullptr;
    TSearchEntry *mSearchEntry = nullptr;
    TPageTool *mPageTool = nullptr;
    TopClassTableConf mTableConf;
    QVariantList mSelectedLst;
};

#endif // TEMPLATECLASS1_H
