﻿#ifndef TOPTEMPLATECLASS6_H
#define TOPTEMPLATECLASS6_H

#include <topcore/topclassabs.h>

class QWidget;
class QTabWidget;
class TopClassAbs;
class TSplitter;
class TTreeView;
class TUiLoader;
class TopTemplateClass6 : public TopClassAbs
{
    Q_OBJECT
public:
    explicit TopTemplateClass6(const QString &iModuleNameStr = QString(""),
                               const QVariantMap &iUrlPars = QVariantMap(),
                               QWidget *iParent = nullptr);
    ~TopTemplateClass6();
public slots:
    TUiLoader *uiLoader();
    QVariantMap uiLoaderValues();
    void onSetUiClicked();
    void onUiTemplateApplied(const QString &iUiStr);
    void reopenTotalTab(const QVariantMap &iTotalData);
    TTreeView* getSubTab(const QVariantMap &iSubData);
    void expandAll();
    void collapseAll();
    void exportExcel();
    QVariantList allTabInfo();
    TTreeView *getTreeView(int iIndex);
    QVariantList getTreeDataLst(int iIndex);
private slots:
    void onTreeViewItemDoubleClicked(const QModelIndex &iIndex);
    void onTabClosedButtomClicked(int index);
private:
    void initUi();
    QString getUiStr();
    void clearTabLst();
private:
    TSplitter *mBodySplitter = nullptr;
    QTabWidget *mTabWidget = nullptr;
    TUiLoader *mUiLoader = nullptr;
    QMap<QModelIndex, TTreeView *> mSubTabMap;
};
#endif // TOPTEMPLATECLASS6_H
