﻿#ifndef TOPTEMPLATECLASS7_H
#define TOPTEMPLATECLASS7_H

#include <topcore/topclassabs.h>
#include <topcore/topclasshelper.h>
#include <tdatabaseutil/tsqlselectorv2.h>

class TSplitter;
class TTableView;
class TUiLoader;
class TPageTool;
class TopTemplateClass7 : public TopClassAbs
{
    Q_OBJECT
public:
    explicit TopTemplateClass7(const QString &iModuleNameStr = QString(""),
                               const QVariantMap &iUrlPars = QVariantMap(),
                               QWidget *iParent = nullptr);
    ~TopTemplateClass7();
public slots:
    QString detailUid() const;
    void setDetailUid(const QString &iUid, bool iForceRefresh = false);
    QVariantList selectedItems() const;
    QVariantList selectedDataMaps() const;
    TTableView *tableView();
    void refresh(bool iResetPage = true);
    void refreshDetail(const QString &iUid);
    TUiLoader *searchUiLoader();
    QVariantMap searchUiValues();
    void resetSearchUiLoader();
    TUiLoader *detailUiLoader();
    QString searchWhere(const QVariantMap &iSearchMap);
    void selectRow(const QString &iId);
signals:
    void detailUidChanged(const QString &iDetailUid);
    void viewConfChanged();
private slots:
    void onSelectionChanged();
    void onPageChanged();
    void onViewConfChanged();
private:
    void initUi();
    void initSearchUiLoader();
    void initDetailUiLoader();
    void initTableView();
private:
    TSplitter *mBodySplitter = nullptr;
    TUiLoader *mSearchUiLoader = nullptr;
    TTableView *mTableView = nullptr;
    TUiLoader *mDetailUiLoader = nullptr;
    TPageTool *mPageTool = nullptr;
    TopClassTableConf mTableConf;
    QString mDetailUid;
    QVariantList mSelectedItems;
};
#endif // TOPTEMPLATECLASS7_H
